fLoadTexture proto hBmp:dword,Wrap:dword
fGetMatrix4f proto lpfMat4:dword,nIndex:dword
fFillMatrix4f proto lpfMat4:dword,nIndex:dword,lpValueReal4:dword

fMat4 struct
	data real4 16 dup (0.0)
fMat4 ends

fVec struct
	i real4 0.0
	j real4 0.0
	k real4 0.0
fVec ends

VERTEX STRUCT
    x REAL4 ?
    y REAL4 ?
    z REAL4 ?
    u REAL4 ?
    v REAL4 ?
VERTEX ENDS

.data
;	m fMat4 <?>
	mat_arr real4 0 dup (16)

.code

glPrint proc uses esi lpText:dword,lpFltX:dword,lpFltY:dword
	
	invoke glPushMatrix
	invoke glMatrixMode,GL_MODELVIEW
	invoke glLoadIdentity
	invoke glPushAttrib,GL_LIST_BIT
	invoke glRasterPos2f,lpFltX,lpFltY
	mov eax,base
	sub eax,32
	invoke glListBase,eax
	invoke lstrlen,lpText
	mov edx,eax
	invoke glCallLists,edx,GL_UNSIGNED_BYTE,lpText
	invoke glPopAttrib
	invoke glPopMatrix
	
	ret
glPrint endp

fEnableOpenGL proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	LOCAL pfd:PIXELFORMATDESCRIPTOR
	LOCAL iFormat:dword
	
	invoke memfill,addr pfd,sizeof 	PIXELFORMATDESCRIPTOR,0
	
	invoke GetDC,hWnd
	mov esi,lphDC
	push eax
	pop [esi]
	mov edi,lpwRC
	mov pfd.nSize,sizeof PIXELFORMATDESCRIPTOR
	mov pfd.nVersion,1
	mov pfd.dwFlags, PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER 
	mov pfd.iPixelType,PFD_TYPE_RGBA
	mov pfd.cColorBits,24
	mov pfd.cDepthBits,16
	mov pfd.iLayerType,PFD_MAIN_PLANE
	
	invoke ChoosePixelFormat,[esi],addr pfd
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at ChoosePixelFormat Function"),0,0
		ret
	.endif
	mov iFormat,eax
	invoke SetPixelFormat,[esi],iFormat,addr pfd
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at SetPixelFormat Function"),0,0
		ret
	.endif
	
	invoke wglCreateContext,[esi]
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at wglCreateContext Function"),0,0
		ret
	.endif
	push eax
	pop [edi]
	
	invoke wglMakeCurrent,[esi],[edi]
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at wglMakeCurrent Function"),0,0
		ret
	.endif
	
	ret
fEnableOpenGL endp

fEnableOpenGLBitmap proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	LOCAL pfd:PIXELFORMATDESCRIPTOR
	LOCAL iFormat:dword
	
	invoke memfill,addr pfd,sizeof 	PIXELFORMATDESCRIPTOR,0
	
	invoke GetDC,hWnd
	mov esi,lphDC
	push eax
	pop [esi]
	mov edi,lpwRC
	mov pfd.nSize,sizeof PIXELFORMATDESCRIPTOR
	mov pfd.nVersion,1
	mov pfd.dwFlags, PFD_SUPPORT_OPENGL or PFD_SUPPORT_GDI or PFD_DRAW_TO_BITMAP
	mov pfd.iPixelType,PFD_TYPE_RGBA
	mov pfd.cColorBits,24
	mov pfd.cDepthBits,16
	mov pfd.iLayerType,PFD_MAIN_PLANE
	
	invoke ChoosePixelFormat,[esi],addr pfd
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at ChoosePixelFormat Function"),0,0
		ret
	.endif
	mov iFormat,eax
	invoke SetPixelFormat,[esi],iFormat,addr pfd
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at SetPixelFormat Function"),0,0
		ret
	.endif
	
	invoke wglCreateContext,[esi]
	.if eax==0
		invoke MessageBox,hWnd,CADD("Failed at wglCreateContext Function"),0,0
		ret
	.endif
	push eax
	pop [edi]
	
	invoke wglMakeCurrent,[esi],[edi]
	.if eax==FALSE
		invoke MessageBox,hWnd,CADD("Failed at wglMakeCurrent Function"),0,0
		ret
	.endif
	
	ret
fEnableOpenGLBitmap endp

fDisableOpenGL proc uses esi edi hWnd:dword,lphDC:dword,lpwRC:dword
	
	invoke wglMakeCurrent,0,0
	mov edx,lpwRC
	invoke wglDeleteContext,[edx]
	ret
fDisableOpenGL endp

